﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;
using Outlook = Microsoft.Office.Interop.Outlook;
using System.IO;
using System.Collections.Generic;

namespace SaveToSharePoint
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("E6176AB2-DCFD-4AA1-9574-562031F7EE26"), ProgId("SaveToSharePoint.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private ADXBackstageView mailReadBackstageView;
        private ADXBackstageFastCommandButton adxButtonSaveAttachments;
        private ImageList imlIcons;
        private ADXBackstageFastCommandButton adxButtonSaveEmail;

        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;

        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AddinModule));
            this.mailReadBackstageView = new AddinExpress.MSO.ADXBackstageView(this.components);
            this.adxButtonSaveAttachments = new AddinExpress.MSO.ADXBackstageFastCommandButton(this.components);
            this.imlIcons = new System.Windows.Forms.ImageList(this.components);
            this.adxButtonSaveEmail = new AddinExpress.MSO.ADXBackstageFastCommandButton(this.components);
            // 
            // mailReadBackstageView
            // 
            this.mailReadBackstageView.Controls.Add(this.adxButtonSaveAttachments);
            this.mailReadBackstageView.Controls.Add(this.adxButtonSaveEmail);
            this.mailReadBackstageView.Id = "mailReadBackstageView_1882e3dbfd914c1c8d8d298aa411df42";
            this.mailReadBackstageView.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookMailRead;
            // 
            // adxButtonSaveAttachments
            // 
            this.adxButtonSaveAttachments.Caption = "Save Attachments to SharePoint Online";
            this.adxButtonSaveAttachments.Id = "adxButtonSaveAttachments_bcf6f9c22a994ccf8b496cbe4d1c80b5";
            this.adxButtonSaveAttachments.Image = 0;
            this.adxButtonSaveAttachments.ImageList = this.imlIcons;
            this.adxButtonSaveAttachments.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxButtonSaveAttachments.InsertAfterIdMso = "FileSaveAs";
            this.adxButtonSaveAttachments.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookMailRead;
            this.adxButtonSaveAttachments.OnClick += new AddinExpress.MSO.ADXRibbonOnClick_EventHandler(this.adxButtonSaveAttachments_OnClick);
            // 
            // imlIcons
            // 
            this.imlIcons.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imlIcons.ImageStream")));
            this.imlIcons.TransparentColor = System.Drawing.Color.Transparent;
            this.imlIcons.Images.SetKeyName(0, "save_as.png");
            this.imlIcons.Images.SetKeyName(1, "SaveAsWebPageHS.png");
            // 
            // adxButtonSaveEmail
            // 
            this.adxButtonSaveEmail.Caption = "Save E-mail to SharePoint Online";
            this.adxButtonSaveEmail.Id = "adxButtonSaveEmail_d8e16232fdec4e75887650b4b5fda586";
            this.adxButtonSaveEmail.Image = 1;
            this.adxButtonSaveEmail.ImageList = this.imlIcons;
            this.adxButtonSaveEmail.ImageTransparentColor = System.Drawing.Color.Transparent;
            this.adxButtonSaveEmail.InsertBeforeIdMso = "SaveAttachments";
            this.adxButtonSaveEmail.Ribbons = AddinExpress.MSO.ADXRibbons.msrOutlookMailRead;
            this.adxButtonSaveEmail.OnClick += new AddinExpress.MSO.ADXRibbonOnClick_EventHandler(this.adxButtonSaveEmail_OnClick);
            // 
            // AddinModule
            // 
            this.AddinName = "SaveToSharePoint";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;

        }
        #endregion

        #region Add-in Express automatic code

        // Required by Add-in Express - do not modify
        // the methods within this region

        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }

        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }

        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }

        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

        private void adxButtonSaveAttachments_OnClick(object sender, IRibbonControl control)
        {
            Outlook.Inspector currInspector = null;
            Outlook.MailItem currMail = null;
            Outlook.Attachments attachments = null;
            int numberOfAttachments = 0;
            Dictionary<string, string> files = new Dictionary<string, string>();
            SharePointHelper spHelper = null;

            try
            {
                currInspector = OutlookApp.ActiveInspector();
                if (currInspector.CurrentItem is Outlook.MailItem)
                {
                    currMail = (Outlook.MailItem)currInspector.CurrentItem;
                    attachments = currMail.Attachments;
                    numberOfAttachments = attachments.Count;
                    if (numberOfAttachments > 0)
                    {
                        spHelper = new SharePointHelper("you@domain.com", "YourPassowrd", "https://yourdomain.sharepoint.com/sites/OutlookTests");
                        for (int i = 1; i <= numberOfAttachments; i++)
                        {
                            Outlook.Attachment attachment = attachments[i];
                            string filePath = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments), attachment.FileName);
                            attachment.SaveAsFile(filePath);
                            files.Add(attachment.FileName, filePath);
                            Marshal.ReleaseComObject(attachment);
                        }

                        foreach (var file in files)
                        {
                            System.Net.HttpStatusCode status = spHelper.UploadFile(file.Value, "/Shared Documents/" + file.Key);
                            if (status != System.Net.HttpStatusCode.Created)
                                MessageBox.Show(file.Key + " failed to upload.");
                        }
                    }
                }
            }
            finally
            {
                if (attachments != null)
                    Marshal.ReleaseComObject(attachments);
                if (currMail != null)
                    Marshal.ReleaseComObject(currMail);
                if (currInspector != null)
                    Marshal.ReleaseComObject(currInspector);
            }
            MessageBox.Show("Done");
        }

        private void adxButtonSaveEmail_OnClick(object sender, IRibbonControl control)
        {
            Outlook.Inspector currInspector = null;
            Outlook.MailItem currMail = null;
            SharePointHelper spHelper = null;
            string fileName = string.Empty;

            try
            {
                currInspector = OutlookApp.ActiveInspector();
                if (currInspector.CurrentItem is Outlook.MailItem)
                {
                    spHelper = new SharePointHelper("you@domain.com", "YourPassowrd", "https://yourdomain.sharepoint.com/sites/OutlookTests");
                    currMail = (Outlook.MailItem)currInspector.CurrentItem;
                    fileName = String.Format("{0} - {1}.msg", SafeFileName(currMail.SenderName), SafeFileName(currMail.Subject));
                    string filePath = Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments), fileName);
                    currMail.SaveAs(filePath, Outlook.OlSaveAsType.olMSG);

                    System.Net.HttpStatusCode status = spHelper.UploadFile(filePath, "/Shared Documents/" + fileName);
                    if (status != System.Net.HttpStatusCode.Created)
                        MessageBox.Show(fileName + " failed to upload.");
                }
            }
            finally
            {
                if (currMail != null)
                    Marshal.ReleaseComObject(currMail);
                if (currInspector != null)
                    Marshal.ReleaseComObject(currInspector);
            }
            MessageBox.Show("Done");
        }

        private string SafeFileName(string name)
        {
            string characters = @"\ / : ; < > { } % * & # ~ ? ( )";
            string[] removeChars = characters.Split(' ');

            foreach (string character in removeChars)
            {
                name = name.Replace(character, "");

            }
            name = name.Replace(" ", "");
            name = name.Replace("\"", "");

            return name;
        }
    }
}

