﻿using System;
using System.IO;
using System.Net;
using Microsoft.SharePoint.Client;
using Wictor.Office365;

namespace SaveToSharePoint
{
    public class SharePointHelper
    {
        public string Username { get; set; }
        public string Password { get; set; }
        public string Url { get; set; }
        public MsOnlineClaimsHelper ClaimsHelper { get; set; }

        public SharePointHelper(string username, string password, string url)
        {
            this.Username = username;
            this.Password = password;
            this.Url = url;
            this.ClaimsHelper = new MsOnlineClaimsHelper(url, username, password);
        }

        public HttpStatusCode UploadFile(string source, string destination)
        {
            using (ClientContext context = new ClientContext(this.Url))
            {
                string fileUrl = this.Url + destination;
                FileStream fileStream = System.IO.File.OpenRead(source);
                int dataLength = Convert.ToInt32(fileStream.Length);
                byte[] data = new byte[dataLength];
                fileStream.Read(data, 0, dataLength);

                HttpWebRequest httpRequest = HttpWebRequest.Create(fileUrl) as HttpWebRequest;
                httpRequest.Method = "PUT";
                httpRequest.Accept = "*/*";
                httpRequest.ContentType = "multipart/form-data; charset=utf-8";
                httpRequest.CookieContainer = this.ClaimsHelper.CookieContainer;
                httpRequest.AllowAutoRedirect = false;
                httpRequest.UserAgent = "Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; WOW64; Trident/5.0)";
                httpRequest.Headers.Add("Accept-Language", "en-us");
                httpRequest.Headers.Add("Translate", "F");
                httpRequest.Headers.Add("Cache-Control", "no-cache");
                httpRequest.ContentLength = fileStream.Length;

                using (Stream stream = httpRequest.GetRequestStream())
                {
                    stream.Write(data, 0, dataLength);
                }

                HttpWebResponse response = (HttpWebResponse)httpRequest.GetResponse();
                return response.StatusCode;
            }
        }
    }
}
